<?php

namespace Api\Aramex\Shipping;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ShipmentCreationRequest' => '\\Api\\Aramex\\Shipping\\StructType\\ShipmentCreationRequest',
            'ClientInfo' => '\\Api\\Aramex\\Shipping\\StructType\\ClientInfo',
            'Transaction' => '\\Api\\Aramex\\Shipping\\StructType\\Transaction',
            'ArrayOfShipment' => '\\Api\\Aramex\\Shipping\\ArrayType\\ArrayOfShipment',
            'Shipment' => '\\Api\\Aramex\\Shipping\\StructType\\Shipment',
            'Party' => '\\Api\\Aramex\\Shipping\\StructType\\Party',
            'Address' => '\\Api\\Aramex\\Shipping\\StructType\\Address',
            'Contact' => '\\Api\\Aramex\\Shipping\\StructType\\Contact',
            'ShipmentDetails' => '\\Api\\Aramex\\Shipping\\StructType\\ShipmentDetails',
            'Dimensions' => '\\Api\\Aramex\\Shipping\\StructType\\Dimensions',
            'Weight' => '\\Api\\Aramex\\Shipping\\StructType\\Weight',
            'Money' => '\\Api\\Aramex\\Shipping\\StructType\\Money',
            'ArrayOfShipmentItem' => '\\Api\\Aramex\\Shipping\\ArrayType\\ArrayOfShipmentItem',
            'ShipmentItem' => '\\Api\\Aramex\\Shipping\\StructType\\ShipmentItem',
            'ArrayOfAttachment' => '\\Api\\Aramex\\Shipping\\ArrayType\\ArrayOfAttachment',
            'Attachment' => '\\Api\\Aramex\\Shipping\\StructType\\Attachment',
            'LabelInfo' => '\\Api\\Aramex\\Shipping\\StructType\\LabelInfo',
            'ShipmentCreationResponse' => '\\Api\\Aramex\\Shipping\\StructType\\ShipmentCreationResponse',
            'ArrayOfNotification' => '\\Api\\Aramex\\Shipping\\ArrayType\\ArrayOfNotification',
            'Notification' => '\\Api\\Aramex\\Shipping\\StructType\\Notification',
            'ArrayOfProcessedShipment' => '\\Api\\Aramex\\Shipping\\ArrayType\\ArrayOfProcessedShipment',
            'ProcessedShipment' => '\\Api\\Aramex\\Shipping\\StructType\\ProcessedShipment',
            'ShipmentLabel' => '\\Api\\Aramex\\Shipping\\StructType\\ShipmentLabel',
            'LabelPrintingRequest' => '\\Api\\Aramex\\Shipping\\StructType\\LabelPrintingRequest',
            'LabelPrintingResponse' => '\\Api\\Aramex\\Shipping\\StructType\\LabelPrintingResponse',
            'PickupCreationRequest' => '\\Api\\Aramex\\Shipping\\StructType\\PickupCreationRequest',
            'Pickup' => '\\Api\\Aramex\\Shipping\\StructType\\Pickup',
            'ArrayOfPickupItemDetail' => '\\Api\\Aramex\\Shipping\\ArrayType\\ArrayOfPickupItemDetail',
            'PickupItemDetail' => '\\Api\\Aramex\\Shipping\\StructType\\PickupItemDetail',
            'Volume' => '\\Api\\Aramex\\Shipping\\StructType\\Volume',
            'PickupCreationResponse' => '\\Api\\Aramex\\Shipping\\StructType\\PickupCreationResponse',
            'ProcessedPickup' => '\\Api\\Aramex\\Shipping\\StructType\\ProcessedPickup',
            'PickupCancelationRequest' => '\\Api\\Aramex\\Shipping\\StructType\\PickupCancelationRequest',
            'PickupCancelationResponse' => '\\Api\\Aramex\\Shipping\\StructType\\PickupCancelationResponse',
        );
    }
}
