<?php

namespace Api\Aramex\Shipping\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Contact StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Contact
 * @subpackage Structs
 */
class Contact extends AbstractStructBase
{
    /**
     * The Department
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Department;
    /**
     * The PersonName
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PersonName;
    /**
     * The Title
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Title;
    /**
     * The CompanyName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CompanyName;
    /**
     * The PhoneNumber1
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PhoneNumber1;
    /**
     * The PhoneNumber1Ext
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PhoneNumber1Ext;
    /**
     * The PhoneNumber2
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PhoneNumber2;
    /**
     * The PhoneNumber2Ext
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PhoneNumber2Ext;
    /**
     * The FaxNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FaxNumber;
    /**
     * The CellPhone
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CellPhone;
    /**
     * The EmailAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EmailAddress;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Type;
    /**
     * Constructor method for Contact
     * @uses Contact::setDepartment()
     * @uses Contact::setPersonName()
     * @uses Contact::setTitle()
     * @uses Contact::setCompanyName()
     * @uses Contact::setPhoneNumber1()
     * @uses Contact::setPhoneNumber1Ext()
     * @uses Contact::setPhoneNumber2()
     * @uses Contact::setPhoneNumber2Ext()
     * @uses Contact::setFaxNumber()
     * @uses Contact::setCellPhone()
     * @uses Contact::setEmailAddress()
     * @uses Contact::setType()
     * @param string $department
     * @param string $personName
     * @param string $title
     * @param string $companyName
     * @param string $phoneNumber1
     * @param string $phoneNumber1Ext
     * @param string $phoneNumber2
     * @param string $phoneNumber2Ext
     * @param string $faxNumber
     * @param string $cellPhone
     * @param string $emailAddress
     * @param string $type
     */
    public function __construct($department = null, $personName = null, $title = null, $companyName = null, $phoneNumber1 = null, $phoneNumber1Ext = null, $phoneNumber2 = null, $phoneNumber2Ext = null, $faxNumber = null, $cellPhone = null, $emailAddress = null, $type = null)
    {
        $this
            ->setDepartment($department)
            ->setPersonName($personName)
            ->setTitle($title)
            ->setCompanyName($companyName)
            ->setPhoneNumber1($phoneNumber1)
            ->setPhoneNumber1Ext($phoneNumber1Ext)
            ->setPhoneNumber2($phoneNumber2)
            ->setPhoneNumber2Ext($phoneNumber2Ext)
            ->setFaxNumber($faxNumber)
            ->setCellPhone($cellPhone)
            ->setEmailAddress($emailAddress)
            ->setType($type);
    }
    /**
     * Get Department value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDepartment()
    {
        return isset($this->Department) ? $this->Department : null;
    }
    /**
     * Set Department value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $department
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setDepartment($department = null)
    {
        // validation for constraint: string
        if (!is_null($department) && !is_string($department)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($department)), __LINE__);
        }
        if (is_null($department) || (is_array($department) && empty($department))) {
            unset($this->Department);
        } else {
            $this->Department = $department;
        }
        return $this;
    }
    /**
     * Get PersonName value
     * @return string|null
     */
    public function getPersonName()
    {
        return $this->PersonName;
    }
    /**
     * Set PersonName value
     * @param string $personName
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setPersonName($personName = null)
    {
        // validation for constraint: string
        if (!is_null($personName) && !is_string($personName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($personName)), __LINE__);
        }
        $this->PersonName = $personName;
        return $this;
    }
    /**
     * Get Title value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitle()
    {
        return isset($this->Title) ? $this->Title : null;
    }
    /**
     * Set Title value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $title
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($title)), __LINE__);
        }
        if (is_null($title) || (is_array($title) && empty($title))) {
            unset($this->Title);
        } else {
            $this->Title = $title;
        }
        return $this;
    }
    /**
     * Get CompanyName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCompanyName()
    {
        return isset($this->CompanyName) ? $this->CompanyName : null;
    }
    /**
     * Set CompanyName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $companyName
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setCompanyName($companyName = null)
    {
        // validation for constraint: string
        if (!is_null($companyName) && !is_string($companyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($companyName)), __LINE__);
        }
        if (is_null($companyName) || (is_array($companyName) && empty($companyName))) {
            unset($this->CompanyName);
        } else {
            $this->CompanyName = $companyName;
        }
        return $this;
    }
    /**
     * Get PhoneNumber1 value
     * @return string|null
     */
    public function getPhoneNumber1()
    {
        return $this->PhoneNumber1;
    }
    /**
     * Set PhoneNumber1 value
     * @param string $phoneNumber1
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setPhoneNumber1($phoneNumber1 = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber1) && !is_string($phoneNumber1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneNumber1)), __LINE__);
        }
        $this->PhoneNumber1 = $phoneNumber1;
        return $this;
    }
    /**
     * Get PhoneNumber1Ext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPhoneNumber1Ext()
    {
        return isset($this->PhoneNumber1Ext) ? $this->PhoneNumber1Ext : null;
    }
    /**
     * Set PhoneNumber1Ext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $phoneNumber1Ext
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setPhoneNumber1Ext($phoneNumber1Ext = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber1Ext) && !is_string($phoneNumber1Ext)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneNumber1Ext)), __LINE__);
        }
        if (is_null($phoneNumber1Ext) || (is_array($phoneNumber1Ext) && empty($phoneNumber1Ext))) {
            unset($this->PhoneNumber1Ext);
        } else {
            $this->PhoneNumber1Ext = $phoneNumber1Ext;
        }
        return $this;
    }
    /**
     * Get PhoneNumber2 value
     * @return string|null
     */
    public function getPhoneNumber2()
    {
        return $this->PhoneNumber2;
    }
    /**
     * Set PhoneNumber2 value
     * @param string $phoneNumber2
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setPhoneNumber2($phoneNumber2 = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber2) && !is_string($phoneNumber2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneNumber2)), __LINE__);
        }
        $this->PhoneNumber2 = $phoneNumber2;
        return $this;
    }
    /**
     * Get PhoneNumber2Ext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPhoneNumber2Ext()
    {
        return isset($this->PhoneNumber2Ext) ? $this->PhoneNumber2Ext : null;
    }
    /**
     * Set PhoneNumber2Ext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $phoneNumber2Ext
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setPhoneNumber2Ext($phoneNumber2Ext = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber2Ext) && !is_string($phoneNumber2Ext)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneNumber2Ext)), __LINE__);
        }
        if (is_null($phoneNumber2Ext) || (is_array($phoneNumber2Ext) && empty($phoneNumber2Ext))) {
            unset($this->PhoneNumber2Ext);
        } else {
            $this->PhoneNumber2Ext = $phoneNumber2Ext;
        }
        return $this;
    }
    /**
     * Get FaxNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFaxNumber()
    {
        return isset($this->FaxNumber) ? $this->FaxNumber : null;
    }
    /**
     * Set FaxNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $faxNumber
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setFaxNumber($faxNumber = null)
    {
        // validation for constraint: string
        if (!is_null($faxNumber) && !is_string($faxNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($faxNumber)), __LINE__);
        }
        if (is_null($faxNumber) || (is_array($faxNumber) && empty($faxNumber))) {
            unset($this->FaxNumber);
        } else {
            $this->FaxNumber = $faxNumber;
        }
        return $this;
    }
    /**
     * Get CellPhone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCellPhone()
    {
        return isset($this->CellPhone) ? $this->CellPhone : null;
    }
    /**
     * Set CellPhone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cellPhone
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setCellPhone($cellPhone = null)
    {
        // validation for constraint: string
        if (!is_null($cellPhone) && !is_string($cellPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cellPhone)), __LINE__);
        }
        if (is_null($cellPhone) || (is_array($cellPhone) && empty($cellPhone))) {
            unset($this->CellPhone);
        } else {
            $this->CellPhone = $cellPhone;
        }
        return $this;
    }
    /**
     * Get EmailAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmailAddress()
    {
        return isset($this->EmailAddress) ? $this->EmailAddress : null;
    }
    /**
     * Set EmailAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $emailAddress
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setEmailAddress($emailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($emailAddress) && !is_string($emailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($emailAddress)), __LINE__);
        }
        if (is_null($emailAddress) || (is_array($emailAddress) && empty($emailAddress))) {
            unset($this->EmailAddress);
        } else {
            $this->EmailAddress = $emailAddress;
        }
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Api\Aramex\Shipping\StructType\Contact
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
